#include <windows.h>
#include "GameVC.h"
#include "CCutsceneShadow.h"
#include "CShadowCamera.h"
#include "CPatch.h"
#include <math.h>

CCamera &TheCamera = *(CCamera*)0x7E4688;
int &m_CurrentStoredValue = *(int*)0xA0CFF8;
float *m_fShadowDisplacementX = (float *)0x7DC0C8;
float *m_fShadowDisplacementY = (float *)0x7DC108;
float *m_fShadowFrontX = (float *)0x813C50;
float *m_fShadowFrontY = (float *)0x813C10;
float *m_fShadowSideX = (float *)0x94B6C8;
float *m_fShadowSideY = (float *)0x94B688;
float &ms_fNearClipZ = *(float*)0x978534;
float &ms_fFarClipZ = *(float*)0xA10678;
short &m_nCurrentPoleShadowStrength = *(short *)0x0A10A38;
short &m_nCurrentShadowStrength = *(short *)0xA10A34;
short& ms_nGameClockSeconds = *(short*)0xA10A5E;
char&  ms_nGameClockMinutes = *(char*)0xA10B5D;
char& ms_nGameClockHours = *(char*)0xA10B33;
RwTexture *gpShadowPedTex = *(RwTexture**)0x9B5F2C;

bool RwFrameDestroy(RwFrame* frame) {
    return ((bool(__cdecl *)(RwFrame*))0x644AD0)(frame);
}

void _rwObjectHasFrameSetFrame(void* object, RwFrame* frame) {
    ((void(__cdecl *)(void*, RwFrame*))0x660CC0)(object, frame);
}

bool RpLightDestroy(RpLight* light) {
    return ((bool(__cdecl *)(RpLight*))0x660AE0)(light);
}

void StoreShadowForCutscenePedObject(void *a1, float a2, float a3, float a4, float a5, float a6, float a7)
{
	((void (__cdecl *)(void *, float, float, float, float, float, float))0x56D5C0)(a1, a2, a3, a4, a5, a6, a7);
}

void CalcPedShadowValues(CVector a1, float *a2, float *a3, float *a4, float *a5, float *a6, float *a7)
{
	((void (__cdecl *)(CVector, float *, float *, float *, float *, float *, float *))0x5692E0)(a1, a2, a3, a4, a5, a6, a7);
}

void StoreShadowToBeRendered(unsigned char a1, RwTexture *a2, CVector *a3, float a4, float a5, float a6, float a7, short a8, unsigned char a9, unsigned char a10, unsigned char a11, float a12, bool a13, float a14, CCutsceneShadow * a15, bool a16)
{
	((void (__cdecl *)(unsigned char, RwTexture *, CVector *, float, float, float, float, short, unsigned char, unsigned char, unsigned char, float, bool, float, CCutsceneShadow *, bool))0x56E6C0)(a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16);
}

RwV3d* RwV3dTransformPoints(RwV3d* pointsOut, const RwV3d* pointsIn, RwInt32 numPoints, const RwMatrix* matrix) {
    return ((RwV3d*(__cdecl *)(RwV3d*, const RwV3d*, RwInt32, const RwMatrix*))0x647160)(pointsOut, pointsIn, numPoints, matrix);
}

CPed * FindPlayerPed()
{
	return ((CPed *(__cdecl *)())0x4BC120)();
}

#define RpAtomicGetFrameMacro(_atomic)                     ((RwFrame *) rwObjectGetParent(_atomic))
#define RpLightGetFrameMacro(_light)                       ((RwFrame *)rwObjectGetParent((_light)))
#define RpLightGetFrame(_light)                            RpLightGetFrameMacro(_light)
#define rwObjectGetParent(object)                          (((const RwObject *)(object))->parent)
	
void Destroy(CCutsceneShadow* This)
{
  This->m_Camera.Destroy();
  This->m_ResampleCamera.Destroy();
  This->m_BlurCamera.Destroy();
  This->m_GradientCamera.Destroy();
  This->m_pAtomic = 0;
  This->m_nRwObjectType = -1;
  if (This->m_pLight)
  {
    _rwObjectHasFrameSetFrame(This->m_pLight, NULL);
	RwFrameDestroy(RpLightGetFrame(This->m_pLight));
    RpLightDestroy(This->m_pLight);
    This->m_pLight = NULL;
  }
}

//TODO
bool CCamera_IsSphereVisible(CCamera *This, CVector const &vPos, float fRadius)
{
	/*
	RwV3d Point = {vPos.x, vPos.y, vPos.z};
	CMatrix m(This->matView);
	RwV3dTransformPoints(&Point, &Point, 1, &m.matrix);
	*/
	RwV3d Point = {vPos.x, vPos.y, vPos.z};
	RwV3dTransformPoints(&Point, &Point, 1, &This->matView.matrix);
	if ( Point.y + fRadius < ms_fNearClipZ )
	{
		if ( Point.y - fRadius <= ms_fFarClipZ )
		{
			if ( Point.y * This->m_avFrustumNormals[0].y + Point.x * This->m_avFrustumNormals[0].x <= fRadius )
			{
				if ( Point.y * This->m_avFrustumNormals[1].y + Point.x * This->m_avFrustumNormals[1].x <= fRadius )
				{
					if ( Point.z * This->m_avFrustumNormals[2].z + Point.y * This->m_avFrustumNormals[2].y <= fRadius )
						return Point.z * This->m_avFrustumNormals[3].z + Point.y * This->m_avFrustumNormals[3].y <= fRadius;
					else
						return false;
				}
				else return false;
			}
			else return false;
		}
		else return false;
	}
	else return false;
}

void StoreShadowForPedObject(CPed *Entity, float sideX, float sideY, float displacementX, float displacementY, float frontX, float frontY)
{
	if ( !Entity->dwTimerUnused )
		Entity->dwTimerUnused = new CCutsceneShadow(); // memory leak
	
	CCutsceneShadow *pCutsceneShadow = Entity->dwTimerUnused;

	if ( pCutsceneShadow )
	{
		CVector pos(Entity->Coords.pos.x, Entity->Coords.pos.y, Entity->Coords.pos.z);
		float fDistSquared = (pos.y - TheCamera.Coords.pos.y) * (pos.y - TheCamera.Coords.pos.y) + (pos.x - TheCamera.Coords.pos.x) * (pos.x - TheCamera.Coords.pos.x);

		if ( fDistSquared <= 2500.0f ) // 169.0f
		{
			/*
			// TODO
			if ( Entity == FindPlayerPed() || CCamera_IsSphereVisible(&TheCamera, Entity->Coords.pos, 2.0f))
			{
			*/
				float fDist = sqrt(fDistSquared);					
				unsigned char color = m_nCurrentPoleShadowStrength;
				short Intensity = m_nCurrentPoleShadowStrength;

				if ( m_nCurrentPoleShadowStrength > 39 )
				{
					if ( m_nCurrentPoleShadowStrength > 100 )
					{
						color = 100;
						Intensity = 100;
					}
				}
				else
				{
					color = 40;
					Intensity = 40;
				}

				pos.x += sideX; pos.y += sideY;
				
				/*
				if ( Entity == FindPlayerPed() )
				{
				*/
					if ( pCutsceneShadow->IsInitialized() && (void *)Entity->m_pRwObject != (void *)pCutsceneShadow->m_pAtomic )
					{
						Destroy(pCutsceneShadow);
					}
					if ( !pCutsceneShadow->IsInitialized() )
					{
						pCutsceneShadow->Create((RwObject*)Entity->m_pRwObject, 8, true, 1, false);
					}
					RwTexture *pRwTexture = pCutsceneShadow->UpdateForCutscene();

					/*
					RwRGBA DorderColor = { 255, 0, 255, 255 };
					pCutsceneShadow->DrawBorderAroundTexture(DorderColor);
					*/
						
					pos.x -= sideX;
					pos.y -= sideY;
						
					float fAgl = 360.0f - (ms_nGameClockSeconds * 0.016667f + (ms_nGameClockMinutes + 60 * ms_nGameClockHours)) * 0.0043633231f * 180.0f * 0.31830987f;
					RwFrame *LightFrame = pCutsceneShadow->SetLightProperties(fAgl, -90.0f, true); //-85.0f cutscene
					CVector LightY(LightFrame->modelling.at.x, LightFrame->modelling.at.y, LightFrame->modelling.at.z);
					LightY.Normalise();
					CalcPedShadowValues(LightY, &displacementX, &displacementY, &frontX, &frontY, &sideX, &sideY);
					pos.x -= 2.5f * sideX;
					pos.y -= 2.5f * sideY;

					StoreShadowToBeRendered(3, pRwTexture, &pos, 1.5f * displacementX, 1.5f * displacementY, 1.5f * frontX, 1.5f * frontY, Intensity, color, color, color, 4.0f, 0, 1.0f, pCutsceneShadow, true);
				/*	
				}
				else
				{
					StoreShadowToBeRendered(1, gpShadowPedTex, &pos, displacementX, displacementY, frontX, frontY, Intensity, color, color, color, 4.0f, 0, 1.0f, 0, true);
				}
			}
			*/
		}
	}
}


void __cdecl StoreShadowForPedObjectDefault(CPed *Entity, float sideX, float sideY, float displacementX, float displacementY, float frontX, float frontY)
{
	CVector pos(Entity->Coords.pos.x, Entity->Coords.pos.y, Entity->Coords.pos.z);  
	float fDistSquared = (pos.y - TheCamera.Coords.pos.y) * (pos.y - TheCamera.Coords.pos.y) + (pos.x - TheCamera.Coords.pos.x) * (pos.x - TheCamera.Coords.pos.x);
			
	if ( fDistSquared <= 169.0f )		
	{
		if ( Entity == FindPlayerPed() || CCamera_IsSphereVisible(&TheCamera, Entity->Coords.pos, 2.0f) )
		{
			int strength;
			float fDist = sqrt(fDistSquared);
			if ( fDist < 6.5f )
				strength = (signed int)((1.0f - (fDist - 6.5f) * 0.15384616f) * (long double)m_nCurrentShadowStrength);
			else
				strength = m_nCurrentShadowStrength;
			
			pos.x += sideX;
			pos.y += sideY;
			
			StoreShadowToBeRendered(1, gpShadowPedTex, &pos, displacementX, displacementY, frontX, frontY, strength, strength, strength, strength, 4.0f, 0, 1.0f, 0, true);
		}
	}
}

BOOL APIENTRY DllMain(HMODULE hModule, DWORD reason, LPVOID lpReserved)
{
	if(reason == DLL_PROCESS_ATTACH)
	{
		CPatch::RedirectCall(0x56DCBA, StoreShadowForPedObject);
		//CPatch::RedirectCall(0x56DCBA, StoreShadowForPedObjectDefault);
	}
	return TRUE;
}